<?php

//////////////////////////////////////////////
//            www.p30light.ir               //
//////////////////////////////////////////////


require_once("server.php");

class Login {

    public static function checkCookieLogin($obj, $email_also = false) {
        if (isset($_COOKIE['loginid']) && isset($_COOKIE['loginvalidation'])) {
            $un = $_COOKIE['loginid'];
            $pw = hash2($_COOKIE['loginvalidation']);
            return Login::isLoginValid($obj, $un, $pw, $email_also);
        } else
            return false;
    }
    
    public static function getCookiePassword() {
        return $_COOKIE['loginvalidation'];
    }

    public static function getUserName() {
        return $_COOKIE['loginid'];
    }

    public static function getLoginID($obj, &$un, $hashed_pw, $email_also = false) {
        //note: this function is sql safe
        return $obj->getLoginID($un, $hashed_pw, $email_also);
    }

    public static function getLoginInfo($obj = NULL) {
        global $db;
        $r['un'] = $_COOKIE['loginid'];
        $r['pw'] = hash2($_COOKIE['loginvalidation']);
        $r = $db->get_as_array($obj->select("where convert(binary(`username`) using utf8)='{$r['un']}' and `password`='{$r['pw']}'"));
        $res = $r[0];
        $res['un'] = $res['username'];
        $res['pw'] = $res['password'];
        //$r['id']= Login::getLoginID($obj, $r['un'], $r['pw'], true);
        return $res;
    }

    public static function isLoginValid($obj, $un, $hashed_pw, $email_also = false) {
        return Login::getLoginID($obj, $un, $hashed_pw, $email_also) > 0;
    }

    public static function doLogin($obj, $un, $original_pw, $cook = true, $email_also = false) {
        //note: this function is sql safe
        $b = Login::isLoginValid($obj, $un, hash_password($original_pw), $email_also);
        if ($b && $cook) {
            //set cookies
            Login::setCookies($un, hash1($original_pw));
        } else {
            //remove cookies
            Login::removeCookies();
        }
        return $b;
    }

    public static function logout() {
        Login::removeCookies();
    }

    public static function setCookies($un, $hash1_pw) {
        $exp = time() + 60 * 60 * 24 * 30;
        setcookie("loginid", $un, $exp);
        setcookie("loginvalidation", $hash1_pw, $exp);
        $_COOKIE['loginid'] = $un;
        $_COOKIE['loginvalidation'] = $hash1_pw;
    }

    protected static function removeCookies() {
        $exp = time() - 10;
        setcookie("loginid", null, $exp);
        setcookie("loginvalidation", null, $exp);
        unset($_COOKIE['loginid']);
        unset($_COOKIE['loginvalidation']);
    }

}

?>